;;; *******************************************************************
;;; * Autor         : Dipl. Ing. Jan Tappenbeck                       *
;;; * Projektname   : QuickLine                                       *
;;; * fr AutoCAD   : R14/R2000/R2000i/R2002/Map4/Map5/IntelliCAD 2001*
;;; *******************************************************************
;;; * Versionsnummer: 1.0                                             *
;;; * Datei         : Quickline.LSP                                   *
;;; * zugehrige DCL: - entfllt -                                    *
;;; * zugehrige SLD: - entfllt -                                    *
;;; * Sprache       : deutsch / international                         *
;;; * nderungen    : ./.                                             *
;;; *******************************************************************
;;; * Kurzbeschreibung:                                               *
;;; * mehrfaches Versetzen von Objekten                               *
;;; *******************************************************************
;;; * Globale Variablen                                               *
;;; * *Q1*, *Q2*                                                      *
;;; *******************************************************************
;;; * (c) Jan Tappenbeck, 10/2001, Germany                            *
;;; * jan.tappenbeck@t-online.de                                      *
;;; *******************************************************************
;;; *                                                                 *
;;; * Lizenz:                                                         *
;;; * Das Programm wird als Freeware-Version freigegeben !            *
;;; *                                                                 *
;;; * Fr Schden, die durch die Anwendung dieses Programmes          *
;;; * entstehen, kann keine Haftung bernommen werden !               *
;;; *                                                                 *
;;; *******************************************************************
;;; *                                                                 *
;;; * Disclaimer:                                                     *
;;; * This software is provided "as is" without express or            *
;;; * implied warranty.                                               *
;;; *                                                                 *
;;; *******************************************************************


(DEFUN C:q (/ qline#olderr p1 p2 OSMODE_start)

  (modes				;speichern der Systemvariablen
    '("CMDECHO"
      "OSMODE"
      "BLIPMODE"
      )
    )
  (SETVAR "CMDECHO" 0)
  (COMMAND "_.UNDO" "_Begin")
  (SETVAR "BLIPMODE" 0)
  (setq OSMODE_start (getvar "OSMODE"))

  (SETQ
    qline#olderr
     *error*				;setzen der internen Fehlerroutine
    *error* qline$err
    )					;end-setq

  (princ
    "\nQuickLine - zum Zeichnen von schnellen Einzellinien"
    )
  (princ
    "\n==================================================="
    )
  (princ "\njan.tappenbeck@t-online.de\n\n")


  (if *Q1*
    (setvar "OSMODE" *Q1*)
    (setvar "OSMODE" OSMODE_start)
    )

  (if (= *Q1* 0)
    (princ "\nKEIN Objektfang aktiv !")
    )


  (if *QT1*
    (setq p1 (getpoint (strcat "\n" *QT1*)))
    (setq p1 (getpoint "\nPunkt 1:"))
    )					;endif

  (if *Q2*
    (setvar "OSMODE" *Q2*)
    (setvar "OSMODE" OSMODE_start)
    )

  (if (= *Q2* 0)
    (princ "\nKEIN Objektfang aktiv !")
    )

  (if *QT2*
    (setq p1 (getpoint (strcat "\n" *QT2*)))
    (setq p2 (getpoint p1 "\nPunkt 2:"))
    )					;endif

  (setvar "OSMODE" 0)			;Basispunkt
  (command "_line" p1 p2 "")


  (SETQ *error* qline#olderr)
  (COMMAND "_.UNDO" "_End")
  (moder)
  (PRINC)
  )

;;------------- Parametereinstellungen ---------------
(DEFUN C:set$q1	(/
		 qline#olderr
		 tmp_txt		;Textvorgabewert
		 answer			;Antworttext
		 )

  (modes				;speichern der Systemvariablen
    '("CMDECHO"
      "OSMODE"
      )
    )
  (SETVAR "CMDECHO" 0)
  (COMMAND "_.UNDO" "_Begin")

  (SETQ
    qline#olderr
     *error*				;setzen der internen Fehlerroutine
    *error* qline$err
    )					;end-setq

  (princ
    "\nQuickLine - Parameter fr den ERSTEN OFang"
    )
  (princ
    "\n=========================================="
    )
  (princ "\njan.tappenbeck@t-online.de\n\n")


  (if *Q1*
    (setvar "OSMODE" *Q1*)
    )					;endif

  (if (wcmatch (getvar "ACADVER") "*15*")
    (command "_.+dsettings" 2)
    (command "_.ddosnap")
    )					;endif

  (setq *Q1* (getvar "OSMODE"))

  (if (not *QT1*)
    (setq tmp_txt "Punkt 1:"
	  *QT1*	  tmp_txt
	  )				;end-setq
    (setq tmp_txt *QT1*)
    )					;endif

  (SETQ	answer
	 (getstring T
		    (STRCAT "\nText fr Punkt (1) <"
			    tmp_txt
			    ">: "
			    )		;end-strcat
		    )			;end-getstring
	)				;end-setq

  (if (/= answer "")
    (SETQ *QT1* answer)
    )					;endif


  (princ (strcat "\nText fr Punkt 1: "
		 *QT1*
		 )			;end-strcat
	 )

  (SETQ *error* qline#olderr)
  (COMMAND "_.UNDO" "_End")
  (moder)
  (PRINC)
  )

(DEFUN C:set$q2	(/
		 qline#olderr
		 tmp_txt		;Textvorgabewert
		 answer			;Antworttext
		 )

  (modes				;speichern der Systemvariablen
    '("CMDECHO"
      "OSMODE"
      )
    )
  (SETVAR "CMDECHO" 0)
  (COMMAND "_.UNDO" "_Begin")

  (SETQ
    qline#olderr
     *error*				;setzen der internen Fehlerroutine
    *error* qline$err
    )					;end-setq

  (princ
    "\nQuickLine - Parameter fr den ZWEITEN OFang"
    )
  (princ
    "\n==========================================="
    )
  (princ "\njan.tappenbeck@t-online.de\n\n")


  (if *Q2*
    (setvar "OSMODE" *Q2*)
    )					;endif

  (if (wcmatch (getvar "ACADVER") "*25*")
    (command "_.+dsettings" 2)
    (command "_.ddosnap")
    )					;endif

  (setq *Q2* (getvar "OSMODE"))

  (if (not *QT2*)
    (setq tmp_txt "Punkt 2:"
	  *QT2*	  tmp_txt
	  )				;end-setq
    (setq tmp_txt *QT2*)
    )					;endif

  (SETQ	answer
	 (getstring T
		    (STRCAT "\nText fr Punkt (2) <"
			    tmp_txt
			    ">: "
			    )		;end-strcat
		    )			;end-getstring
	)				;end-setq

  (if (/= answer "")
    (SETQ *QT2* answer)
    )					;endif

  (princ (strcat "\nText fr Punkt 2: 	"
		 *QT2*
		 )			;end-strcat
	 )

  (SETQ *error* qline#olderr)
  (COMMAND "_.UNDO" "_End")
  (moder)
  (PRINC)
  )
;;----------------- Fehlerroutinen     ---------------
(DEFUN moder ()				; Rcksetzen der Systemvariablen - Unterprogramm
  (REPEAT (LENGTH mlst)
    (SETVAR (CAAR mlst) (CADAR mlst))
    (SETQ mlst (CDR mlst))
    )
  )

(DEFUN modes (a)			;speichern der Systemvariablen
  (SETQ mlst '())
  (REPEAT (LENGTH a)
    (SETQ mlst (APPEND mlst (LIST (LIST (CAR a) (GETVAR (CAR a))))))
    (SETQ a (CDR a))
    )
  )

(DEFUN qline$err (s)			;interne Fehlerroutine
  (IF (/= s "Funktion abgebrochen")
    (PRINC (STRCAT "\nFehler: " s))
    )
  (SETQ *error* qline#olderr)
  (COMMAND "_.UNDO" "_End")
  (COMMAND "_u")
  (moder)
  (PRINC)
  )

(princ
  "\nQuickLine - zum Zeichnen von schnellen Einzellinien"
  )
(princ
  "\n==================================================="
  )
(princ "\njan.tappenbeck@t-online.de\n\n")
(princ "\nProgrammstart: Q")
(princ)
 ;|Visual LISP Format Options
(72 2 40 1 nil "end of " 60 9 0 0 0 T T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
